var express      = require('express');
var path         = require('path');
var favicon      = require('serve-favicon');
var logger       = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser   = require('body-parser');

var Helper    = require('./app/helper')
,   Log       = require('./app/logging.js')
,   Version   = require('./package.json')
,   Conf      = require('./config.json')
,   Radio     = require('./app/radio');


var app = express();
var routes = require('./routes/routes');


// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));
app.set('tools_root', __dirname + '/bin/');


Log.init(app);
app.set('Log', Log);
Log.log("Kitchen Radio " + Version.version + " is waking up ...", true);
Log.debug('Kitchen Radio root: ' + app.get('tools_root'));


/**
 * Init Helper.
 */
Helper.init(app);
app.set('Helper', Helper);

/**
 * Init Radio.
 */
var radioInstance = Radio.init(app, Conf);
app.set('Radio', radioInstance);
radioInstance.play();


/**
 * Routing ...
 */
routes.init(app);
app.set('Routes', routes);
app.use('/action/play/:id/', routes.play);
app.use('/', routes.index);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  var err = new Error('Not Found');
  err.status = 404;
  next(err);
});


// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
  app.use(function(err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
      message: err.message,
      error: err
    });
  });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
  res.status(err.status || 500);
  res.render('error', {
    message: err.message,
    error: {}
  });
});


module.exports = app;
